---
title: Resource URLs
slug: Web/HTTP/Basics_of_HTTP/Resource_URLs
tags:
  - Guide
  - HTTP
  - Intermediate
  - Resource
---
<p>{{HTTPSidebar}}{{non-standard_header}}</p>

<p>Resource URLs, URLs prefixed with the <code>resource:</code> scheme, are used by Firefox and Firefox browser extensions to load resources internally, but some of the information is available to sites the browser connects to as well.</p>

<h2 id="Syntax">Syntax</h2>

<p>Resource URLs are composed of two parts: a prefix (<code>resource:</code>), and a URL pointing to the resource you want to load:</p>

<pre class="syntaxbox">resource://&lt;url&gt;</pre>

<p>An example:</p>

<pre>resource://gre/res/svg.css</pre>

<p>When arrows are found in the resource URL's ('-&gt;'), it means that the first file loaded the next one:</p>

<pre>resource://&lt;File-loader&gt; -&gt; &lt;File-loaded&gt;</pre>

<p>Please refer to <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Identifying_resources_on_the_Web">Identifying resources on the web</a> for more general details.</p>

<p>In this article, we focus on resource URIs, which are used internally by Firefox to point to built-in resources.</p>

<h2 id="Threats">Threats</h2>

<p>Because some of the information shared by <code>resource:</code> URLs is available to websites, a web page could run internal scripts and inspect internal resources of Firefox, including the default preferences, which could be a serious security and privacy issue.</p>

<p>For example, <a href="https://www.browserleaks.com/firefox">a script on Browserleaks</a> highlights what Firefox reveals when queried by a simple script running on the site (you can find the code in <a href="https://browserleaks.com/firefox#more">https://browserleaks.com/firefox#more</a>).</p>

<p>The file firefox.js passes preference names and values to the pref() function. For example:</p>

<pre><a href="http://searchfox.org/mozilla-central/rev/48ea452803907f2575d81021e8678634e8067fc2/browser/app/profile/firefox.js#575">http://searchfox.org/mozilla-central/rev/48ea452803907f2575d81021e8678634e8067fc2/browser/app/profile/firefox.js#575</a></pre>

<p>Web sites can easily collect Firefox default preferences by overriding this <code>pref()</code> function and using the script <code>resource:///defaults/preferences/firefox.js</code>.</p>

<p>Furthermore, some default values of preferences differ between build configurations, such as platform and locale, which means web sites could identify individual users using this information.</p>

<h2 id="Solution">Solution</h2>

<p>In order to fix this problem, Mozilla changed the behavior of loading resource: URIs in {{bug(863246)}}, which landed in <a href="/en-US/docs/Mozilla/Firefox/Releases/57">Firefox 57 (Quantum)</a>.</p>

<p>In the past, web content was able to access whatever <code>resource:</code> URIs were desired — not only Firefox’s internal resources, but also extensions’ assets.  Now this behavior is prohibited by default.</p>

<p>It is however still necessary for Firefox to load resources in web content under certain circumstances.  For example, if you open the view source page (View Page Source or View Selection Source), you will find it requires <code>viewsource.css</code> through a <code>resource:</code> URI.  Resources that have to be exposed to web content have been moved to a new location named <code>resource://content-accessible/</code>, which is isolated and only contains non-sensitive resources.  In this way we can keep essential resources exposed and have most threats eliminated.</p>

<div class="note">
<p><strong>Note</strong>: It is recommended that web and extension developers don’t try to use resource URLs anymore. Their usage was hacky at best, and most usage won’t work any more.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<p>resource: is not defined in any specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>resource: is Firefox only.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Identifying_resources_on_the_Web">Identifying resources on the Web</a></li>
 <li><a href="/en-US/docs/Learn/Common_questions/What_is_a_URL">What is a URL?</a></li>
 <li><a href="https://www.iana.org/assignments/uri-schemes/uri-schemes.xhtml">IANA list of URI schemes</a> (<code>resource:</code> is <a href="https://www.iana.org/assignments/uri-schemes/prov/resource">covered here</a>)</li>
</ul>

